#include "moglclass.h"
#include <glm/gtc/matrix_transform.hpp>

namespace moglclass
{
	class Arcball
	{
	public:
		Arcball(int w=600, int h=600);
		~Arcball();

		void setBounds(int w, int h);
		void startRotation(int x, int y);
		void updateRotation(int x, int y);
		void stopRotation();
		glm::mat4 getRotationMatrix();
		void setRadius(float newRadius) { ballRadius = newRadius; }
		void reset();

	private:
		int width, height;

		glm::mat4 currentMatrix;
		glm::vec3 startRotationVector;
		glm::vec3 currentRotationVector;

		bool isRotating;
		float ballRadius;
		double residualSpin;

		glm::vec3 convertXY(int mx, int my);
	};
}
